        INCDIR  Includes:
        INCLUDE whdload.i
        INCLUDE whdmacros.i
        INCLUDE lvo/dos.i

        IFD BARFLY
        OUTPUT  "GunbeeF99.Slave"
        BOPT    O+                              ;enable optimizing
        BOPT    OG+                             ;enable optimizing
        BOPT    ODd-                            ;disable mul optimizing
        BOPT    ODe-                            ;disable mul optimizing
        BOPT    w4-                             ;disable 64k warnings
        BOPT    wo-                             ;disable optimize warnings
        SUPER
        ENDC

;============================================================================
;_Flash
;_Flash0
;_Flash1
;_Flash2
CHIPMEMSIZE     = $200000
FASTMEMSIZE     = $80000*1
NUMDRIVES       = 1
WPDRIVES        = %0000

QUIT_AFTER_PROGRAM_EXIT
;BLACKSCREEN
;BOOTBLOCK
BOOTDOS
;BOOTEARLY
CBDOSLOADSEG
;CBDOSREAD
;CACHE
;DEBUG
;DISKSONBOOT
DOSASSIGN
FONTHEIGHT     = 8
HDINIT
INITAGA
;INIT_AUDIO
;INIT_GADTOOLS
;INIT_LOWLEVEL
;INIT_MATHFFP
HRTMON
;IOCACHE         = 1024
;MEMFREE        = $200
;NEEDFPU
;POINTERTICKS   = 1
;SETPATCH
;STACKSIZE      = 6000
;TRDCHANGEDISK

;============================================================================

slv_Version     = 16
slv_Flags       = WHDLF_NoError|WHDLF_Examine|WHDLF_EmulTrap
slv_keyexit     = $59   ;F10

;============================================================================

        INCLUDE Sources:whdload/kick31.s

;============================================================================

        IFD BARFLY
        IFND    .passchk
        DOSCMD  "WDate  >T:date"
.passchk
        ENDC
        ENDC

slv_CurrentDir          dc.b    "data",0
slv_name                dc.b    "GunBee F-99 (The kidnapping of lady Akiko)",0
slv_copy                dc.b    "1998 APC & TCP/Twin Eagles.",0
slv_info                dc.b    "coded by CFou!",10
                dc.b    "Version 1.1 "
        IFD BARFLY
                INCBIN  "T:date"
        ENDC
                dc.b    0
        EVEN

;============================================================================
; like a program from "startup-sequence" executed, full dos process,
; HDINIT is required

; the following example is extensive because it saves all registers and
;   restores them before executing the program, the reason for this that some
;   programs (e.g. MANX Aztec-C) require specific registers properly setup on
;   calling
; in most cases a simpler routine is sufficient :-)

        IFD BOOTDOS

_bootdos        lea     (_saveregs,pc),a0
                movem.l d1-d6/a2-a6,(a0)
                move.l  (a7)+,(44,a0)
                move.l  (_resload,pc),a2        ;A2 = resload

    movem.l d0-a6,-(a7)
    ;get tags
      lea   (_tag,pc),a0
      move.l _resload(pc),a2
      jsr   (resload_Control,a2)
    movem.l (a7)+,d0-a6

                         
        ;open doslib
                lea     (_dosname,pc),a1
                move.l  (4),a6
                jsr     (_LVOOldOpenLibrary,a6)
                lea     (_dosbase,pc),a0
                move.l  d0,(a0)
                move.l  d0,a6                   ;A6 = dosbase

 IFD _Flash0
.t
 move.w #$f0,$dff180
 btst #6,$bfe001
 bne .t
 ENDC

        ;assigns
                lea     (_disk1,pc),a0
                sub.l   a1,a1
                bsr     _dos_assign
                lea     (_disk2,pc),a0
                sub.l   a1,a1
                bsr     _dos_assign


        ;load exe
                move.l _custom2(pc),d7
                tst.l d7
                beq .ok2
                lea     (_program2,pc),a0
                bra .skip2
.ok2
                lea     (_program,pc),a0
.skip2
                move.l  a0,d1
                jsr     (_LVOLoadSeg,a6)
                move.l  d0,d7                   ;D7 = segment
                beq     .program_err

        ;patch
                lea     (_pl_program,pc),a0
                move.l  d7,a1
                jsr     (resload_PatchSeg,a2)

        IFD DEBUG
        ;set debug
                clr.l   -(a7)
                move.l  d7,-(a7)
                pea     WHDLTAG_DBGSEG_SET
                move.l  a7,a0
                jsr     (resload_Control,a2)
                add.w   #12,a7
        ENDC

        ;call
        IFND QUIT_AFTER_PROGRAM_EXIT
                lea     (_saveseg,pc),a0
                move.l  d7,(a0)
        ENDC
                move.l  d7,a1
                add.l   a1,a1
                add.l   a1,a1
                moveq   #_args_end-_args,d0
                lea     (_args,pc),a0
                movem.l (_saveregs,pc),d1-d6/a2-a6
                bsr _Patch
                jsr     (4,a1)

        IFD QUIT_AFTER_PROGRAM_EXIT
                pea     TDREASON_OK
                move.l  (_resload,pc),a2
                jmp     (resload_Abort,a2)
        ELSE
        ;remove exe
                move.l  (_saveseg,pc),d1
                move.l  (_dosbase,pc),a6
                jsr     (_LVOUnLoadSeg,a6)

                moveq   #0,d0
                move.l  (_saverts,pc),-(a7)
                rts
        ENDC

.program_err    jsr     (_LVOIoErr,a6)
                move.l _custom2(pc),d7
                tst.l d7
                beq .ok
                pea     (_program2,pc)
                bra .skip0
.ok
                pea     (_program,pc)
.skip0
                move.l  d0,-(a7)
                pea     TDREASON_DOSREAD
                jmp     (resload_Abort,a2)

_pl_program     PL_START
                PL_END

_disk1          dc.b    "F99_disk1",0
_disk2          dc.b    "F99_disk2",0
_program        dc.b    "Gunbee_f99",0
_program2       dc.b    "HighScoreMixer",0
_args           dc.b    10
_args_end       dc.b    0
        EVEN

_saveregs       ds.l    11
_saverts        dc.l    0
        IFND QUIT_AFTER_PROGRAM_EXIT
_saveseg        dc.l    0
        ENDC
_dosbase        dc.l    0

_Patch
 movem.l d0-a6,-(a7)

 IFD _Flash
.t
 move.w #$f0,$dff180
 btst #6,$bfe001
 bne .t
 ENDC

 add.l #$485c8-$1a414,a1
 cmp.w #$d1c1,(a1)
 bne .pas
 pea _Debug(pc)
 move.l (a7)+,$80+4*7
 move.w #$4e40+7,(a1)
.pas
 sub.l #$485c8-$1a414,a1


 move.l _custom1(pc),d0

 btst #0,d0
 beq .s1
 add.l #$302e4-$1a414,a1
 cmp.w #$9041,(a1)
 bne .pasL
 move.w #$4e71,(a1) ; unlimited lives
.pasL
 sub.l #$302e4-$1a414,a1
.s1

 btst #1,d0
 beq .s2
 add.l #$2ed46-$1a414,a1
 cmp.w #$9041,(a1)
 bne .pasF
 move.w #$4e71,(a1) ; unlimited Fire Beams
.pasF
 sub.l #$2ed46-$1a414,a1
.s2

 tst.l d0
 beq .ok
 add.l #$2783e-$1a414,a1
 cmp.w #$4eb9,(a1)
 bne .pasFS
; sub.l #6,2(a1) ; no save HighScore
 pea _exit(pc)
 move.l (a7)+,2(a1)
.pasFS
 sub.l #$2783e-$1a414,a1
.ok
 movem.l (a7)+,d0-a6
 rts

_exit
                pea     TDREASON_OK
                move.l  (_resload,pc),a2
                jmp     (resload_Abort,a2)

_Debug
; move.w #$f,$dff180
; and.l #$ffff,d1
 add.l d1,a0
 add.l #8,a0
 cmp.l a0,a1
 bhi .ok
; move.w #$f00,$dff180
 move.l a1,a0
 rte
.ok
 sub.l #8,a0
 rte              

_tag
               dc.l  WHDLTAG_CUSTOM1_GET
_custom1       dc.l  0
               dc.l  WHDLTAG_CUSTOM2_GET
_custom2       dc.l  0
 dc.l  0       ; End

        ENDC

  

;============================================================================
; callback/hook which gets executed after each successful call to dos.LoadSeg
; can also be used instead of _bootdos, requires the presence of
; "startup-sequence"

; the following example uses a parameter table to patch different executables
; after they get loaded

        IFD CBDOSLOADSEG

; D0 = BSTR name of the loaded program as BCPL string
; D1 = BPTR segment list of the loaded program as BCPL pointer

_cb_dosLoadSeg  lsl.l   #2,d0           ;-> APTR
                move.l  d0,a0
                moveq   #0,d0
                move.b  (a0)+,d0        ;D0 = name length
        ;remove leading path
                move.l  a0,a1
                move.l  d0,d2
.2              move.b  (a1)+,d3
                subq.l  #1,d2
                cmp.b   #":",d3
                beq     .1
                cmp.b   #"/",d3
                beq     .1
                tst.l   d2
                bne     .2
                bra     .3
.1              move.l  a1,a0           ;A0 = name
                move.l  d2,d0           ;D0 = name length
                bra     .2
.3      ;get hunk length sum
                move.l  d1,a1           ;D1 = segment
                moveq   #0,d2
.add            add.l   a1,a1
                add.l   a1,a1
                add.l   (-4,a1),d2      ;D2 = hunks length
                subq.l  #8,d2           ;hunk header
                move.l  (a1),a1
                move.l  a1,d7
                bne     .add

        ;search patch
                lea     (.patch,pc),a1
.next           move.l  (a1)+,d3
                movem.w (a1)+,d4-d5
;                beq     .end
                cmp.l #0,d4
                beq .end
                cmp.l #0,d3 ; diskfont library
                beq .try
 IFD _Flash1
.t
 move.w #$f00,$dff180
 btst #6,$bfe001
 bne .t
 ENDC
                cmp.l   d2,d3           ;length match?
                bne     .next
.try
 IFD _Flash2
.tt
 move.w #$f,$dff180
 btst #6,$bfe001
 bne .tt
 ENDC
        ;compare name
                lea     (.patch,pc,d4.w),a2
                move.l  a0,a3
                move.l  d0,d6
.cmp            move.b  (a3)+,d7
                cmp.b   #"a",d7
                blo     .l
                cmp.b   #"z",d7
                bhi     .l
                sub.b   #$20,d7
.l              cmp.b   (a2)+,d7
                bne     .next
                subq.l  #1,d6
                bne     .cmp
                tst.b   (a2)
                bne     .next
        ;set debug
        IFD DEBUG
                clr.l   -(a7)
                move.l  d1,-(a7)
                pea     WHDLTAG_DBGSEG_SET
                move.l  a7,a0
                move.l  (_resload,pc),a2
                jsr     (resload_Control,a2)
                move.l  (4,a7),d1
                add.w   #12,a7
        ENDC
        ;patch
                lea     (.patch,pc,d5.w),a0
                move.l  d1,a1
                bsr _PatchDiskFont
                move.l  (_resload,pc),a2
                jsr     (resload_PatchSeg,a2)
        ;end
.end            rts

PATCH   MACRO
                dc.l    \1              ;cumulated size of hunks (not filesize!)
                dc.w    \2-.patch       ;name
                dc.w    \3-.patch       ;patch list
        ENDM

.patch          ;PATCH   $3b3c,.n_run,_p_runDiskFont ; wb 3.0 & 3.1
                PATCH   0,.n_run,_p_runDiskFont ; wb 3.0 & 3.1
                dc.l    0,0,0

        ;all upper case!
.n_run          dc.b    "DISKFONT.LIBRARY",0
        EVEN

_p_runDiskFont      PL_START
        ;       PL_P    0,.1
                PL_END
_PatchDiskFont
 movem.l d0-a6,-(a7)

                move.l _expmem(pc),a0
                add.l #$26694,a0
                cmp.l #'ENV:',(a0)
                bne .skip
                move.l #'SYS:',(a0)            ; remove diskfont pb
.skip

 add.l d1,d1
 add.l d1,d1
 move.l d1,a0
 move.l a0,a1
 add.l -4(a0),a1

.enc
 cmp.b #'E',0(a0)
 bne .next
 cmp.b #'N',1(a0)
 bne .next
 cmp.b #'V',2(a0)
 bne .next
 cmp.b #':',3(a0)
 bne .next
 move.b #'S',0(a0)
 move.b #'Y',1(a0)
 move.b #'S',2(a0)
 bne .next
.next
 add.l #1,a0
 cmp.l a0,a1
 bne .enc

 movem.l (a7)+,d0-a6
 rts
        ENDC
     
        END


